Browse Source

Initial pixelfed app

Bob Mottram 6 years ago
parent
commit
6262163073
1 changed files with 426 additions and 0 deletions
  1. 426
    0
      src/freedombone-app-pixelfed

+ 426
- 0
src/freedombone-app-pixelfed View File

@@ -0,0 +1,426 @@
1
+#!/bin/bash
2
+#
3
+#  _____               _           _
4
+# |   __|___ ___ ___ _| |___ _____| |_ ___ ___ ___
5
+# |   __|  _| -_| -_| . | . |     | . | . |   | -_|
6
+# |__|  |_| |___|___|___|___|_|_|_|___|___|_|_|___|
7
+#
8
+#                              Freedom in the Cloud
9
+#
10
+# License
11
+# =======
12
+#
13
+# Copyright (C) 2018 Bob Mottram <bob@freedombone.net>
14
+#
15
+# This program is free software: you can redistribute it and/or modify
16
+# it under the terms of the GNU Affero General Public License as published by
17
+# the Free Software Foundation, either version 3 of the License, or
18
+# (at your option) any later version.
19
+#
20
+# This program is distributed in the hope that it will be useful,
21
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
22
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
23
+# GNU Affero General Public License for more details.
24
+#
25
+# You should have received a copy of the GNU Affero General Public License
26
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
27
+
28
+VARIANTS='full full-vim'
29
+
30
+IN_DEFAULT_INSTALL=0
31
+SHOW_ON_ABOUT=1
32
+
33
+PIXELFED_DOMAIN_NAME=
34
+PIXELFED_CODE=
35
+PIXELFED_ONION_PORT=9324
36
+PIXELFED_REPO="https://github.com/dansup/pixelfed"
37
+PIXELFED_COMMIT='9fbc5d0902fbc2042a6d2bb698cc3802e7b25508'
38
+
39
+# These parameters are used by the FreedomBox mobile app
40
+PIXELFED_SHORT_DESCRIPTION='Federated image sharing'
41
+PIXELFED_DESCRIPTION='Federated image sharing'
42
+PIXELFED_MOBILE_APP_URL=
43
+
44
+pixelfed_variables=(ONION_ONLY
45
+                    PIXELFED_DOMAIN_NAME
46
+                    PIXELFED_CODE
47
+                    DDNS_PROVIDER
48
+                    MY_USERNAME)
49
+
50
+function logging_on_pixelfed {
51
+    echo -n ''
52
+}
53
+
54
+function logging_off_pixelfed {
55
+    echo -n ''
56
+}
57
+
58
+function remove_user_pixelfed {
59
+    remove_username="$1"
60
+
61
+    "${PROJECT_NAME}-pass" -u "$remove_username" --rmapp pixelfed
62
+}
63
+
64
+function add_user_pixelfed {
65
+    new_username="$1"
66
+    new_user_password="$2"
67
+
68
+    "${PROJECT_NAME}-pass" -u "$new_username" -a pixelfed -p "$new_user_password"
69
+    echo '0'
70
+}
71
+
72
+function install_interactive_pixelfed {
73
+    if [ ! "$ONION_ONLY" ]; then
74
+        ONION_ONLY='no'
75
+    fi
76
+
77
+    if [[ "$ONION_ONLY" != "no" ]]; then
78
+        PIXELFED_DOMAIN_NAME='pixelfed.local'
79
+        write_config_param "PIXELFED_DOMAIN_NAME" "$PIXELFED_DOMAIN_NAME"
80
+    else
81
+        interactive_site_details "pixelfed" "PIXELFED_DOMAIN_NAME" "PIXELFED_CODE"
82
+    fi
83
+    APP_INSTALLED=1
84
+}
85
+
86
+function change_password_pixelfed {
87
+    curr_username="$1"
88
+    new_user_password="$2"
89
+
90
+    read_config_param 'PIXELFED_DOMAIN_NAME'
91
+
92
+    "${PROJECT_NAME}-pass" -u "$curr_username" -a pixelfed -p "$new_user_password"
93
+}
94
+
95
+function pixelfed_create_database {
96
+    if [ -f "$IMAGE_PASSWORD_FILE" ]; then
97
+        PIXELFED_ADMIN_PASSWORD="$(printf "%d" "$(cat "")")"
98
+    else
99
+        if [ ! "$PIXELFED_ADMIN_PASSWORD" ]; then
100
+            PIXELFED_ADMIN_PASSWORD=$(create_password "${MINIMUM_PASSWORD_LENGTH}")
101
+        fi
102
+    fi
103
+    if [ ! "$PIXELFED_ADMIN_PASSWORD" ]; then
104
+        return
105
+    fi
106
+
107
+    create_database pixelfed "$PIXELFED_ADMIN_PASSWORD" "$MY_USERNAME"
108
+}
109
+
110
+function reconfigure_pixelfed {
111
+    # This is used if you need to switch identity. Dump old keys and generate new ones
112
+    echo -n ''
113
+}
114
+
115
+function configure_interactive_pixelfed {
116
+    W=(1 $"Option 1"
117
+       2 $"Option 2")
118
+
119
+    while true
120
+    do
121
+        # shellcheck disable=SC2068
122
+        selection=$(dialog --backtitle $"Freedombone Administrator Control Panel" --title $"pixelfed" --menu $"Choose an operation, or ESC for main menu:" 14 70 3 "${W[@]}" 3>&2 2>&1 1>&3)
123
+
124
+        if [ ! "$selection" ]; then
125
+           break
126
+        fi
127
+        case $selection in
128
+            1) # call some function for option 1
129
+               ;;
130
+            2) # call some function for option 2
131
+               ;;
132
+        esac
133
+    done
134
+}
135
+
136
+function upgrade_pixelfed {
137
+    CURR_PIXELFED_COMMIT=$(get_completion_param "pixelfed commit")
138
+    if [[ "$CURR_PIXELFED_COMMIT" == "$PIXELFED_COMMIT" ]]; then
139
+        return
140
+    fi
141
+
142
+    if grep -q "pixelfed domain" "$COMPLETION_FILE"; then
143
+        PIXELFED_DOMAIN_NAME=$(get_completion_param "pixelfed domain")
144
+    fi
145
+
146
+    # update to the next commit
147
+    set_repo_commit "/var/www/$PIXELFED_DOMAIN_NAME/htdocs" "pixelfed commit" "$PIXELFED_COMMIT" "$PIXELFED_REPO"
148
+
149
+    cd "/var/www/${PIXELFED_DOMAIN_NAME}/htdocs" || exit 634873561
150
+    install_composer
151
+
152
+    chown -R www-data:www-data "/var/www/${PIXELFED_DOMAIN_NAME}/htdocs"
153
+}
154
+
155
+function backup_local_pixelfed {
156
+    PIXELFED_DOMAIN_NAME='pixelfed'
157
+    if grep -q "pixelfed domain" "$COMPLETION_FILE"; then
158
+        PIXELFED_DOMAIN_NAME=$(get_completion_param "pixelfed domain")
159
+    fi
160
+
161
+    source_directory=/var/www/${PIXELFED_DOMAIN_NAME}/htdocs
162
+
163
+    suspend_site "${PIXELFED_DOMAIN_NAME}"
164
+
165
+    dest_directory=pixelfed
166
+    backup_directory_to_usb "$source_directory" $dest_directory
167
+
168
+    backup_database_to_usb pixelfed
169
+
170
+    restart_site
171
+}
172
+
173
+function restore_local_pixelfed {
174
+    if ! grep -q "pixelfed domain" "$COMPLETION_FILE"; then
175
+        return
176
+    fi
177
+    PIXELFED_DOMAIN_NAME=$(get_completion_param "pixelfed domain")
178
+    if [ ! "$PIXELFED_DOMAIN_NAME" ]; then
179
+        return
180
+    fi
181
+    suspend_site "${PIXELFED_DOMAIN_NAME}"
182
+    temp_restore_dir=/root/temppixelfed
183
+    pixelfed_dir=/var/www/${PIXELFED_DOMAIN_NAME}/htdocs
184
+
185
+    pixelfed_create_database
186
+
187
+    restore_database pixelfed
188
+    if [ -d $temp_restore_dir ]; then
189
+        rm -rf $temp_restore_dir
190
+    fi
191
+
192
+    restore_directory_from_usb $temp_restore_dir pixelfed
193
+    if [ -d $temp_restore_dir ]; then
194
+        if [ -d "$temp_restore_dir$pixelfed_dir" ]; then
195
+            cp -rp "$temp_restore_dir$pixelfed_dir"/* "$pixelfed_dir"/
196
+        else
197
+            if [ ! -d "$pixelfed_dir" ]; then
198
+                mkdir "$pixelfed_dir"
199
+            fi
200
+            cp -rp "$temp_restore_dir"/* "$pixelfed_dir"/
201
+        fi
202
+        chown -R www-data:www-data "$pixelfed_dir"
203
+        rm -rf $temp_restore_dir
204
+    fi
205
+    restart_site
206
+}
207
+
208
+function backup_remote_pixelfed {
209
+    PIXELFED_DOMAIN_NAME='pixelfed'
210
+    if grep -q "pixelfed domain" "$COMPLETION_FILE"; then
211
+        PIXELFED_DOMAIN_NAME=$(get_completion_param "pixelfed domain")
212
+    fi
213
+
214
+    source_directory=/var/www/${PIXELFED_DOMAIN_NAME}/htdocs
215
+
216
+    suspend_site "${PIXELFED_DOMAIN_NAME}"
217
+
218
+    dest_directory=pixelfed
219
+    backup_directory_to_friend "$source_directory" $dest_directory
220
+    backup_database_to_friend pixelfed
221
+
222
+
223
+    restart_site
224
+}
225
+
226
+function restore_remote_pixelfed {
227
+    if ! grep -q "pixelfed domain" "$COMPLETION_FILE"; then
228
+        return
229
+    fi
230
+    PIXELFED_DOMAIN_NAME=$(get_completion_param "pixelfed domain")
231
+    if [ ! "$PIXELFED_DOMAIN_NAME" ]; then
232
+        return
233
+    fi
234
+    suspend_site "${PIXELFED_DOMAIN_NAME}"
235
+    temp_restore_dir=/root/temppixelfed
236
+    pixelfed_dir=/var/www/${PIXELFED_DOMAIN_NAME}/htdocs
237
+
238
+    pixelfed_create_database
239
+
240
+    restore_database_from_friend pixelfed
241
+    if [ -d "$temp_restore_dir" ]; then
242
+        rm -rf $temp_restore_dir
243
+    fi
244
+
245
+    restore_directory_from_friend $temp_restore_dir pixelfed
246
+    if [ -d $temp_restore_dir ]; then
247
+        if [ -d "$temp_restore_dir$pixelfed_dir" ]; then
248
+            cp -rp "$temp_restore_dir$pixelfed_dir"/* "$pixelfed_dir"/
249
+        else
250
+            if [ ! -d "$pixelfed_dir" ]; then
251
+                mkdir "$pixelfed_dir"
252
+            fi
253
+            cp -rp $temp_restore_dir/* "$pixelfed_dir"/
254
+        fi
255
+        chown -R www-data:www-data "$pixelfed_dir"
256
+        rm -rf $temp_restore_dir
257
+    fi
258
+    restart_site
259
+}
260
+
261
+function remove_pixelfed {
262
+    nginx_dissite "$PIXELFED_DOMAIN_NAME"
263
+    remove_certs "$PIXELFED_DOMAIN_NAME"
264
+
265
+
266
+    if [ -d "/var/www/$PIXELFED_DOMAIN_NAME" ]; then
267
+        rm -rf "/var/www/$PIXELFED_DOMAIN_NAME"
268
+    fi
269
+    if [ -f "/etc/nginx/sites-available/$PIXELFED_DOMAIN_NAME" ]; then
270
+        rm "/etc/nginx/sites-available/$PIXELFED_DOMAIN_NAME"
271
+    fi
272
+    drop_database pixelfed
273
+    remove_onion_service pixelfed "${PIXELFED_ONION_PORT}"
274
+    if grep -q "pixelfed" /etc/crontab; then
275
+        sed -i "/pixelfed/d" /etc/crontab
276
+    fi
277
+    remove_app pixelfed
278
+    remove_completion_param install_pixelfed
279
+    sed -i '/pixelfed/d' "$COMPLETION_FILE"
280
+
281
+    remove_ddns_domain "$PIXELFED_DOMAIN_NAME"
282
+}
283
+
284
+function install_pixelfed {
285
+    install_mariadb
286
+
287
+    get_mariadb_password
288
+
289
+    apt-get -yq install php-gettext php-curl php-gd php-mysql git curl
290
+    apt-get -yq install memcached php-memcached php-intl exiftool libfcgi0ldbl
291
+    apt-get -yq install redis-server php-redis autoconf imagemagick imagemagick-dev libtool
292
+
293
+    if [ ! "$PIXELFED_DOMAIN_NAME" ]; then
294
+        echo $'No domain name was given'
295
+        exit 3568356
296
+    fi
297
+
298
+    if [ -d "/var/www/$PIXELFED_DOMAIN_NAME/htdocs" ]; then
299
+        rm -rf "/var/www/$PIXELFED_DOMAIN_NAME/htdocs"
300
+    fi
301
+    if [ -d /repos/pixelfed ]; then
302
+        mkdir "/var/www/$PIXELFED_DOMAIN_NAME/htdocs"
303
+        cp -r -p /repos/pixelfed/. "/var/www/$PIXELFED_DOMAIN_NAME/htdocs"
304
+        cd "/var/www/$PIXELFED_DOMAIN_NAME/htdocs" || exit 324687356
305
+        git pull
306
+    else
307
+        git_clone "$PIXELFED_REPO" "/var/www/$PIXELFED_DOMAIN_NAME/htdocs"
308
+    fi
309
+
310
+    if [ ! -d "/var/www/$PIXELFED_DOMAIN_NAME/htdocs" ]; then
311
+        echo $'Unable to clone pixelfed repo'
312
+        exit 87525
313
+    fi
314
+
315
+    cd "/var/www/$PIXELFED_DOMAIN_NAME/htdocs" || exit 36587356
316
+    git checkout "$PIXELFED_COMMIT" -b "$PIXELFED_COMMIT"
317
+    set_completion_param "pixelfed commit" "$PIXELFED_COMMIT"
318
+
319
+    chmod g+w "/var/www/$PIXELFED_DOMAIN_NAME/htdocs"
320
+    chown -R www-data:www-data "/var/www/$PIXELFED_DOMAIN_NAME/htdocs"
321
+
322
+    pixelfed_create_database
323
+
324
+    add_ddns_domain "$PIXELFED_DOMAIN_NAME"
325
+
326
+    PIXELFED_ONION_HOSTNAME=$(add_onion_service pixelfed 80 "${PIXELFED_ONION_PORT}")
327
+
328
+    pixelfed_nginx_site=/etc/nginx/sites-available/$PIXELFED_DOMAIN_NAME
329
+    if [[ "$ONION_ONLY" == "no" ]]; then
330
+        nginx_http_redirect "$PIXELFED_DOMAIN_NAME" "index index.php"
331
+        { echo 'server {';
332
+          echo '  listen 443 ssl;';
333
+          echo '  #listen [::]:443 ssl;';
334
+          echo "  server_name $PIXELFED_DOMAIN_NAME;";
335
+          echo ''; } >> "$pixelfed_nginx_site"
336
+        nginx_compress "$PIXELFED_DOMAIN_NAME"
337
+        echo '' >> "$pixelfed_nginx_site"
338
+        echo '  # Security' >> "$pixelfed_nginx_site"
339
+        nginx_ssl "$PIXELFED_DOMAIN_NAME"
340
+
341
+        nginx_security_options "$PIXELFED_DOMAIN_NAME"
342
+
343
+        { echo '  add_header Strict-Transport-Security max-age=15768000;';
344
+          echo '';
345
+          echo '    access_log /dev/null;';
346
+          echo '    error_log /dev/null;';
347
+          echo '';
348
+          echo "    root /var/www/$PIXELFED_DOMAIN_NAME/htdocs;";
349
+          echo '';
350
+          echo '  index index.php;';
351
+          echo '  location ~ \.php {';
352
+          echo '    include snippets/fastcgi-php.conf;';
353
+          echo '    fastcgi_pass unix:/var/run/php/php7.0-fpm.sock;';
354
+          echo '    fastcgi_read_timeout 30;';
355
+          echo '    fastcgi_param HTTPS on;';
356
+          echo '  }';
357
+          echo '';
358
+          echo '  # Location';
359
+          echo '  location / {'; } >> "$pixelfed_nginx_site"
360
+        nginx_limits "$PIXELFED_DOMAIN_NAME" '15m'
361
+        { echo "    try_files \$uri \$uri/ /index.php?\$args;";
362
+          echo '  }';
363
+          echo '}'; } >> "$pixelfed_nginx_site"
364
+    else
365
+        echo -n '' > "$pixelfed_nginx_site"
366
+    fi
367
+    { echo 'server {';
368
+      echo "    listen 127.0.0.1:$PIXELFED_ONION_PORT default_server;";
369
+      echo "    server_name $PIXELFED_ONION_HOSTNAME;";
370
+      echo ''; } >> "$pixelfed_nginx_site"
371
+    nginx_compress "$PIXELFED_DOMAIN_NAME"
372
+    echo '' >> "$pixelfed_nginx_site"
373
+    nginx_security_options "$PIXELFED_DOMAIN_NAME"
374
+    { echo '';
375
+      echo '    access_log /dev/null;';
376
+      echo '    error_log /dev/null;';
377
+      echo '';
378
+      echo "    root /var/www/$PIXELFED_DOMAIN_NAME/htdocs;";
379
+      echo '';
380
+      echo '  index index.php;';
381
+      echo '  location ~ \.php {';
382
+      echo '    include snippets/fastcgi-php.conf;';
383
+      echo '    fastcgi_pass unix:/var/run/php/php7.0-fpm.sock;';
384
+      echo '    fastcgi_read_timeout 30;';
385
+      echo '    fastcgi_param HTTPS off;';
386
+      echo '  }';
387
+      echo '';
388
+      echo '  # Location';
389
+      echo '  location / {'; } >> "$pixelfed_nginx_site"
390
+    nginx_limits "$PIXELFED_DOMAIN_NAME" '15m'
391
+    { echo "    try_files \$uri \$uri/ index.php?\$args;";
392
+      echo '  }';
393
+      echo '}'; } >> "$pixelfed_nginx_site"
394
+
395
+    configure_php
396
+
397
+    cd "/var/www/$PIXELFED_DOMAIN_NAME/htdocs" || exit 36587357
398
+
399
+    cp "/var/www/$PIXELFED_DOMAIN_NAME/htdocs/.env.example" "/var/www/$PIXELFED_DOMAIN_NAME/htdocs/.env"
400
+    sed -i "s|APP_URL=http://.*|APP_URL=https://\$PIXELFED_DOMAIN_NAME|g" "/var/www/$PIXELFED_DOMAIN_NAME/htdocs/.env"
401
+    sed -i "s|DB_DATABASE=.*|DB_DATABASE=pixelfed|g" "/var/www/$PIXELFED_DOMAIN_NAME/htdocs/.env"
402
+    sed -i "s|DB_USERNAME=.*|DB_USERNAME=root|g" "/var/www/$PIXELFED_DOMAIN_NAME/htdocs/.env"
403
+    sed -i "s|DB_PASSWORD=.*|DB_PASSWORD=$MARIADB_PASSWORD|g" "/var/www/$PIXELFED_DOMAIN_NAME/htdocs/.env"
404
+    sed -i "s|MAIL_HOST=.*|MAIL_HOST=localhost|g" "/var/www/$PIXELFED_DOMAIN_NAME/htdocs/.env"
405
+    sed -i "s|MAIL_PORT=.*|MAIL_PORT=25|g" "/var/www/$PIXELFED_DOMAIN_NAME/htdocs/.env"
406
+
407
+    install_composer
408
+    chown -R www-data:www-data "/var/www/$PIXELFED_DOMAIN_NAME/htdocs"
409
+
410
+    create_site_certificate "$PIXELFED_DOMAIN_NAME" 'yes'
411
+
412
+    nginx_ensite "$PIXELFED_DOMAIN_NAME"
413
+
414
+    systemctl restart mariadb
415
+
416
+    systemctl restart php7.0-fpm
417
+
418
+    systemctl restart nginx
419
+
420
+    "${PROJECT_NAME}-pass" -u "$MY_USERNAME" -a pixelfed -p "$PIXELFED_ADMIN_PASSWORD"
421
+    set_completion_param "pixelfed domain" "$PIXELFED_DOMAIN_NAME"
422
+
423
+    APP_INSTALLED=1
424
+}
425
+
426
+# NOTE: deliberately there is no "exit 0"